import { delegateEvents as ve, getNextElement as m, getNextMarker as b, insert as k, createComponent as c, effect as oe, setAttribute as be, runHydrationEvents as ce, template as h, spread as Ye, hydrate as Ze, render as Ge } from "solid-js/web";
import { createSignal as z, onMount as ye, onCleanup as Je, For as et, Show as v, createEffect as tt, createContext as nt, useContext as ot } from "solid-js";
import { Compartment as $e, SelectionRange as rt, EditorSelection as it, RangeSetBuilder as we, Transaction as at, EditorState as lt } from "@codemirror/state";
import { EditorView as R, Decoration as L, ViewPlugin as _e, keymap as st } from "@codemirror/view";
import { syntaxTree as de, syntaxHighlighting as ct, HighlightStyle as dt } from "@codemirror/language";
import { defaultKeymap as ut, historyKeymap as ft, indentMore as gt, indentLess as pt, history as mt } from "@codemirror/commands";
import { markdown as ht, markdownLanguage as kt } from "@codemirror/lang-markdown";
import { languages as bt } from "@codemirror/language-data";
import { tags as d } from "@lezer/highlight";
const xt = "data-ink-mde-ssr-hydration-marker", vt = `[${xt}]`, yt = () => ({}), H = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, $t = (e) => {
  if (Object.prototype.toString.call(e) === H.object)
    return `[object ${e.constructor.name}]`;
}, j = (e, t) => $t(e) === t, wt = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), o = (r, i) => n.get(r) || (j(r, H.object) && n.set(r, !0), j(i, H.undefined)) ? r : j(r, H.array) && j(i, H.array) ? [...i] : j(r, H.object) && j(i, H.object) ? Object.keys(r).reduce((l, a) => (Object.hasOwnProperty.call(i, a) ? l[a] = o(r[a], i[a]) : l[a] = r[a], l), {}) : i;
  return o(e, t);
}, P = (e, t) => wt(e, t);
var V = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(V || {}), _t = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))(_t || {}), g = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(g || {}), re = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e))(re || {}), ie = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(ie || {});
const xe = () => document.createElement("div"), Ce = () => window.matchMedia("(prefers-color-scheme: dark)").matches, Ct = (e) => e === V.Dark ? !0 : e === V.Light ? !1 : Ce(), ne = (e) => {
  const t = [
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    { suffix: "modal-position", default: "fixed" },
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" }
  ], n = !Ct(e.options.interface.appearance);
  return t.map((o) => {
    const r = n && o.light ? o.light : o.default;
    return `--ink-internal-${o.suffix}: var(--ink-${o.suffix}, ${r});`;
  });
}, Lt = (e) => [
  R.theme({}, { dark: e })
], St = (e) => e.extensions.map((t) => t.initialValue(e)), ue = (e) => Promise.all(
  e.extensions.map((t) => t.reconfigure(e.options))
), Mt = (e) => {
  const t = new $e();
  return {
    compartment: t,
    initialValue: (n) => t.of(e(n.options)),
    reconfigure: (n) => t.reconfigure(e(n))
  };
}, At = (e) => {
  const t = new $e();
  return {
    compartment: t,
    initialValue: (n) => t.of([]),
    reconfigure: (n) => e(n, t)
  };
}, Dt = () => [
  ...Ht.map((e) => Mt(e)),
  ...zt.map((e) => At(e))
], Ht = [
  (e) => {
    const t = e.interface.appearance === V.Dark, n = e.interface.appearance === V.Auto;
    return Lt(t || n && Ce());
  }
], zt = [
  async (e, t) => {
    if (e.interface.autocomplete) {
      const { autocomplete: n } = await import("./autocomplete.eef6ac6b.js");
      return t.reconfigure(n(e));
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.images) {
      const { images: n } = await import("./images.0bde9a43.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.lists) {
      const { lists: n } = await import("./lists.b465ff74.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.readonly) {
      const { readonly: n } = await import("./readonly.90b28a57.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.spellcheck) {
      const { spellcheck: n } = await import("./spellcheck.7e0765c7.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.vim) {
      const { vim: n } = await import("./vim.e0ec79d3.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  }
], ae = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: V.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      lists: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    plugins: [],
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    editor: {},
    extensions: Dt(),
    options: e,
    root: xe(),
    target: xe()
  };
}, Bt = (e) => P(ae(), e), fe = (e, t = {}) => {
  const [n, o] = z(Bt({ ...t, options: e }));
  return [n, o];
}, Et = ([e]) => {
  const { editor: t } = e();
  t.destroy();
}, le = ([e]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, _ = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), jt = {
  [g.Bold]: _({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [g.Code]: _({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [g.CodeBlock]: _({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [g.Heading]: _({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [g.Image]: _({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [g.Italic]: _({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [g.Link]: _({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [g.OrderedList]: _({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [g.Quote]: _({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [g.TaskList]: _({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [g.List]: _({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, Le = ([e, t], n) => {
  const { editor: o } = e(), r = o.lineBlockAt(n.start), i = o.lineBlockAt(n.end);
  return { start: r.from, end: i.to };
}, Vt = ([e, t], n) => {
  const { editor: o } = e();
  let r = n.start;
  const i = [];
  for (; r <= n.end; ) {
    const l = o.lineBlockAt(r), a = Math.max(r, l.from), s = Math.min(r, l.to);
    i.push({ start: a, end: s }), r = l.to + 1;
  }
  return i;
}, Ot = ([e, t], n) => {
  const { editor: o } = e(), r = o.state.wordAt(n.start)?.from || n.start, i = o.state.wordAt(n.end)?.to || n.end;
  return { start: r, end: i };
}, Nt = ([e, t], n) => n || Z([e, t]).pop() || { start: 0, end: 0 }, Se = ([e, t], n) => {
  const { editor: o } = e();
  return o.state.sliceDoc(n.start, n.end);
}, ge = ([e, t], n, o) => Tt(e(), o).find(({ type: i }) => n.nodes.includes(i.name)), Tt = ({ editor: { state: e } }, t) => {
  const n = [];
  return de(e).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: o, from: r, to: i }) => {
      n.push({ type: o, from: r, to: i });
    }
  }), n;
}, pe = ([e, t], n, o) => {
  const r = Se([e, t], o), i = n.prefix.length, l = n.suffix.length * -1 || r.length, a = r.slice(i, l);
  O([e, t], a, o);
}, qt = ([e, t], n, o) => {
  const r = Le([e, t], o), i = ge([e, t], n, r);
  if (i) {
    const l = i.from, a = i.to;
    pe([e, t], n, { start: l, end: a });
  } else {
    const l = n.prefix, a = n.suffix;
    G([e, t], { before: l, after: a, selection: r });
  }
}, It = ([e, t], n, o) => {
  Vt([e, t], o).forEach((i) => {
    Me([e, t], n, i);
  });
}, Me = ([e, t], n, o) => {
  const r = Le([e, t], o), i = ge([e, t], n, r), l = n.prefixStates.length > 0;
  if (i && l)
    n.prefixStates.find((a, s) => {
      const u = i.from, x = i.to, y = Se([e, t], { start: u, end: x }), C = y.startsWith(a);
      return C && O([e, t], y.replace(new RegExp(`^${a}`), n.prefixStates[s + 1]), { start: u, end: x }), C;
    });
  else if (i) {
    const a = i.from, s = i.to;
    pe([e, t], n, { start: a, end: s });
  } else {
    const a = n.prefix, s = n.suffix;
    G([e, t], { before: a, after: s, selection: r });
  }
}, Rt = ([e, t], n, o) => {
  const r = ge([e, t], n, o);
  if (r) {
    const i = r.from, l = r.to;
    pe([e, t], n, { start: i, end: l });
  } else {
    const { start: i, end: l } = Ot([e, t], o), a = Array.isArray(n.prefix) ? n.prefix[0] : n.prefix, s = n.suffix;
    G([e, t], { before: a, after: s, selection: { start: i, end: l } });
  }
}, Ae = ([e, t], n, { selection: o } = {}) => {
  const r = jt[n], i = Nt([e, t], o);
  r.block ? qt([e, t], r, i) : r.multiline ? It([e, t], r, i) : r.line ? Me([e, t], r, i) : Rt([e, t], r, i);
}, Pt = ([e]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, De = (e) => {
  const t = e.map((n) => rt.fromJSON({ anchor: n.start, head: n.end }));
  return it.create(t);
}, Wt = (e) => e.ranges.map((n) => ({
  end: n.anchor < n.head ? n.head : n.anchor,
  start: n.head < n.anchor ? n.head : n.anchor
})), Z = ([e]) => {
  const { editor: t } = e();
  return Wt(t.state.selection);
}, O = ([e, t], n, o, r = !1) => {
  const { editor: i } = e();
  let l = o?.start, a = o?.end || o?.start;
  if (typeof l > "u") {
    const u = Z([e, t]).pop();
    l = u.start, a = u.end;
  }
  const s = { changes: { from: l, to: a, insert: n } };
  if (r) {
    const u = l === a ? l + n.length : l, x = l + n.length;
    Object.assign(s, { selection: { anchor: u, head: x } });
  }
  i.dispatch(
    i.state.update(s)
  );
}, Ft = [
  "Blockquote"
], Ut = L.line({ attributes: { class: "cm-blockquote" } }), Xt = L.line({ attributes: { class: "cm-blockquote-open" } }), Kt = L.line({ attributes: { class: "cm-blockquote-close" } }), Qt = _e.define((e) => ({
  update: () => Yt(e)
}), { decorations: (e) => e.update() }), Yt = (e) => {
  const t = new we(), n = de(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      n.iterate({
        enter({ type: l, from: a, to: s }) {
          if (l.name !== "Document" && Ft.includes(l.name)) {
            t.add(i.from, i.from, Ut);
            const u = e.state.doc.lineAt(a), x = e.state.doc.lineAt(s);
            return u.number === i.number && t.add(i.from, i.from, Xt), x.number === i.number && t.add(i.from, i.from, Kt), !1;
          }
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return t.finish();
}, Zt = () => [
  Qt
], Gt = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], N = {
  "data-enable-grammarly": "false",
  "data-gramm": "false",
  "data-grammarly-skip": "true",
  spellcheck: "false"
}, Jt = L.line({ attributes: { ...N, class: "cm-codeblock" } }), en = L.line({ attributes: { ...N, class: "cm-codeblock-open" } }), tn = L.line({ attributes: { ...N, class: "cm-codeblock-close" } }), nn = L.mark({ attributes: { ...N, class: "cm-code" } }), on = L.mark({ attributes: { ...N, class: "cm-code cm-code-open" } }), rn = L.mark({ attributes: { ...N, class: "cm-code cm-code-close" } }), an = _e.define((e) => ({
  update: () => ln(e)
}), { decorations: (e) => e.update() }), ln = (e) => {
  const t = new we(), n = de(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      let l;
      n.iterate({
        enter({ type: a, from: s, to: u }) {
          if (a.name !== "Document")
            if (Gt.includes(a.name)) {
              t.add(i.from, i.from, Jt);
              const x = e.state.doc.lineAt(s), y = e.state.doc.lineAt(u);
              return x.number === i.number && t.add(i.from, i.from, en), y.number === i.number && t.add(i.from, i.from, tn), !1;
            } else
              a.name === "InlineCode" ? l = { from: s, to: u, innerFrom: s, innerTo: u } : a.name === "CodeMark" && (s === l.from ? (l.innerFrom = u, t.add(s, u, on)) : u === l.to && (l.innerTo = s, t.add(l.innerFrom, l.innerTo, nn), t.add(s, u, rn)));
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return t.finish();
}, sn = () => [
  an
], cn = () => [
  R.editorAttributes.of({
    class: "ink-mde-editor"
  }),
  R.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
], dn = () => [
  ...cn()
], un = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: t }) => e.selection.ranges.some((n) => !n.empty) ? gt({ state: e, dispatch: t }) : (t(
      e.update(e.replaceSelection("  "), {
        scrollIntoView: !0,
        annotations: at.userEvent.of("input")
      })
    ), !0),
    shift: pt
  }
], fn = () => st.of([
  ...un,
  ...ut,
  ...ft
]), gn = () => R.lineWrapping, pn = () => [
  ct(
    dt.define([
      {
        tag: d.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: d.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      {
        tag: d.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: d.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: d.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      {
        tag: d.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      {
        tag: d.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      {
        tag: d.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: d.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: d.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: d.definition(d.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: d.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: d.definition(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: d.local(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: d.special(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      {
        tag: d.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: d.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: d.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: d.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: d.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: d.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: d.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      {
        tag: d.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: d.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: d.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: d.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: d.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: d.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      {
        tag: d.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: d.special(d.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      {
        tag: d.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], mn = (e) => {
  if (e.length > 0)
    return De(e);
}, He = (e) => {
  const t = e.options.plugins.flatMap((o) => o.type === re.Default ? o.value : []), n = e.options.plugins.flatMap((o) => o.type === re.Grammar ? o.value : []);
  return lt.create({
    doc: e.options.doc,
    selection: mn(e.options.selections),
    extensions: [
      ...St(e),
      Zt(),
      sn(),
      mt(),
      dn(),
      fn(),
      gn(),
      ht({
        base: kt,
        codeLanguages: bt,
        extensions: n
      }),
      pn(),
      ...t
    ]
  });
}, hn = ([e, t], n) => {
  t(P(e(), { options: { doc: n } })), e().editor.setState(He(e()));
}, kn = ([e]) => e().options, bn = async ([e, t], n) => {
  const o = t(P(e(), { options: n })), r = await ue(o);
  o.editor.dispatch({ effects: r });
}, ze = (e, t = {}) => {
  if (t.selections)
    return Be(e, t.selections);
  if (t.selection)
    return se(e, t.selection);
  if (t.at)
    return xn(e, t.at);
}, xn = (e, t) => {
  const [n] = e;
  if (t === ie.Start)
    return se(e, { start: 0, end: 0 });
  if (t === ie.End) {
    const o = n().editor.state.doc.length;
    return se(e, { start: o, end: o });
  }
}, Be = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      selection: De(t)
    })
  );
}, se = (e, t) => Be(e, [t]), vn = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      changes: {
        from: 0,
        to: n.state.doc.length,
        insert: t
      }
    })
  );
}, G = ([e, t], { after: n, before: o, selection: r }) => {
  const { editor: i } = e(), l = r || Z([e, t]).pop() || { start: 0, end: 0 }, a = i.state.sliceDoc(l.start, l.end);
  O([e, t], `${o}${a}${n}`, l), ze([e, t], { selections: [{ start: l.start + o.length, end: l.end + o.length }] });
}, Ee = (e) => ({
  destroy: Et.bind(void 0, e),
  focus: le.bind(void 0, e),
  format: Ae.bind(void 0, e),
  getDoc: Pt.bind(void 0, e),
  insert: O.bind(void 0, e),
  load: hn.bind(void 0, e),
  options: kn.bind(void 0, e),
  reconfigure: bn.bind(void 0, e),
  select: ze.bind(void 0, e),
  selections: Z.bind(void 0, e),
  update: vn.bind(void 0, e),
  wrap: G.bind(void 0, e)
}), yn = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, $n = /* @__PURE__ */ h("<span>uploading files...</span>", 2), wn = /* @__PURE__ */ h('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 18), _n = /* @__PURE__ */ h('<img class="ink-drop-zone-file-preview-image">', 1), Cn = /* @__PURE__ */ h("<span>drop files here</span>", 2), Ln = () => {
  const [e, t] = z(0), [n, o] = z([]), [r, i] = z(!1), [l, a] = z(!1), [s, u] = W(), x = () => {
    a(!1);
  }, y = (f) => {
    if (s().options.files.dragAndDrop) {
      f.preventDefault(), f.stopPropagation();
      const p = f.dataTransfer;
      p?.files ? E(p.files) : (t(0), a(!1), o([]));
    }
  }, C = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(e() + 1), a(!0));
  }, S = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(e() - 1), e() === 0 && a(!1));
  }, M = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), a(!0));
  }, A = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), t(0), a(!1));
  }, B = (f) => {
    if (s().options.files.clipboard) {
      f.preventDefault();
      const p = f.clipboardData;
      p?.files && p.files.length > 0 && E(p.files);
    }
  }, E = (f) => {
    Array.from(f).forEach((p) => {
      o([...n(), p]);
    }), i(!0), a(!0), Promise.resolve(s().options.files.handler(f)).then((p) => {
      if (s().options.files.injectMarkup && p) {
        const T = `![](${p})`;
        O([s, u], T);
      }
    }).finally(() => {
      t(0), i(!1), a(!1), o([]);
    });
  };
  return ye(() => {
    document.addEventListener("dragenter", C), document.addEventListener("dragleave", S), document.addEventListener("dragover", M), document.addEventListener("drop", A), s().root.addEventListener("paste", B);
  }), Je(() => {
    document.removeEventListener("dragenter", C), document.removeEventListener("dragleave", S), document.removeEventListener("dragover", M), document.removeEventListener("drop", A), s().root.removeEventListener("paste", B);
  }), (() => {
    const f = m(wn), p = f.firstChild, T = p.nextSibling, D = T.firstChild, F = D.firstChild, J = F.nextSibling, [U, ee] = b(J.nextSibling), te = D.nextSibling;
    return p.textContent = yn, D.addEventListener("drop", y), k(F, c(et, {
      get each() {
        return n().slice(0, 8);
      },
      children: (X) => (() => {
        const q = m(_n);
        return oe((w) => {
          const K = X.name, I = URL.createObjectURL(X);
          return K !== w._v$ && be(q, "alt", w._v$ = K), I !== w._v$2 && be(q, "src", w._v$2 = I), w;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), q;
      })()
    })), k(D, c(v, {
      get when() {
        return r();
      },
      get fallback() {
        return m(Cn);
      },
      get children() {
        return m($n);
      }
    }), U, ee), te.$$click = x, oe(() => f.classList.toggle("visible", !!l())), ce(), f;
  })();
};
ve(["click"]);
const Sn = (e) => {
  const t = new R({
    dispatch: (n) => {
      const { options: o } = e;
      o.hooks.beforeUpdate(n.newDoc.toString()), t.update([n]), n.docChanged && o.hooks.afterUpdate(n.newDoc.toString());
    },
    state: He(e)
  });
  return t;
}, Mn = () => {
  const [e, t] = W(), n = Sn(e());
  return t(P(e(), {
    editor: n
  })), ue(e()).then((o) => {
    n.dispatch({
      effects: o
    });
  }), n.dom;
}, An = /* @__PURE__ */ h('<button class="ink-button" type="button"></button>', 2), $ = (e) => (() => {
  const t = m(An);
  return t.$$click = (n) => e.onclick(n), k(t, () => e.children), ce(), t;
})();
ve(["click"]);
const Dn = `.ink .ink-toolbar{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);bottom:.25rem;color:inherit;display:flex;flex-shrink:0;gap:2rem;overflow:auto;padding:.25rem;position:sticky;top:.25rem;z-index:10}.ink .ink-toolbar-group{display:flex}.ink .ink-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink .ink-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink .ink-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, Hn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), zn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), Bn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), En = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), jn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), Vn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), On = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), Nn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), Tn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), qn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), In = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), Rn = /* @__PURE__ */ h('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), Pn = /* @__PURE__ */ h('<input type="file">', 1), Wn = /* @__PURE__ */ h('<div class="ink-toolbar"><style></style><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div></div>', 36), Fn = () => {
  const [e, t] = W(), [n, o] = z(), r = (a) => {
    Ae([e, t], a), le([e, t]);
  }, i = (a) => {
    const s = a.target;
    s?.files && Promise.resolve(e().options.files.handler(s.files)).then((u) => {
      const x = `![](${u})`;
      O([e, t], x), le([e, t]);
    });
  }, l = () => {
    n()?.click();
  };
  return (() => {
    const a = m(Wn), s = a.firstChild, u = s.nextSibling, x = u.firstChild, [y, C] = b(x.nextSibling), S = y.nextSibling, [M, A] = b(S.nextSibling), B = M.nextSibling, [E, f] = b(B.nextSibling), p = u.nextSibling, T = p.firstChild, [D, F] = b(T.nextSibling), J = D.nextSibling, [U, ee] = b(J.nextSibling), te = U.nextSibling, [X, q] = b(te.nextSibling), w = p.nextSibling, K = w.firstChild, [I, Oe] = b(K.nextSibling), Ne = I.nextSibling, [me, Te] = b(Ne.nextSibling), qe = me.nextSibling, [Ie, Re] = b(qe.nextSibling), Q = w.nextSibling, Pe = Q.firstChild, [he, We] = b(Pe.nextSibling), Fe = he.nextSibling, [ke, Ue] = b(Fe.nextSibling), Xe = ke.nextSibling, [Ke, Qe] = b(Xe.nextSibling);
    return s.textContent = Dn, k(u, c(v, {
      get when() {
        return e().options.toolbar.heading;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Heading),
          get children() {
            return m(Hn);
          }
        });
      }
    }), y, C), k(u, c(v, {
      get when() {
        return e().options.toolbar.bold;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Bold),
          get children() {
            return m(zn);
          }
        });
      }
    }), M, A), k(u, c(v, {
      get when() {
        return e().options.toolbar.italic;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Italic),
          get children() {
            return m(Bn);
          }
        });
      }
    }), E, f), k(p, c(v, {
      get when() {
        return e().options.toolbar.quote;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Quote),
          get children() {
            return m(En);
          }
        });
      }
    }), D, F), k(p, c(v, {
      get when() {
        return e().options.toolbar.codeBlock;
      },
      get children() {
        return c($, {
          onclick: () => r(g.CodeBlock),
          get children() {
            return m(jn);
          }
        });
      }
    }), U, ee), k(p, c(v, {
      get when() {
        return e().options.toolbar.code;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Code),
          get children() {
            return m(Vn);
          }
        });
      }
    }), X, q), k(w, c(v, {
      get when() {
        return e().options.toolbar.list;
      },
      get children() {
        return c($, {
          onclick: () => r(g.List),
          get children() {
            return m(On);
          }
        });
      }
    }), I, Oe), k(w, c(v, {
      get when() {
        return e().options.toolbar.orderedList;
      },
      get children() {
        return c($, {
          onclick: () => r(g.OrderedList),
          get children() {
            return m(Nn);
          }
        });
      }
    }), me, Te), k(w, c(v, {
      get when() {
        return e().options.toolbar.taskList;
      },
      get children() {
        return c($, {
          onclick: () => r(g.TaskList),
          get children() {
            return m(Tn);
          }
        });
      }
    }), Ie, Re), k(Q, c(v, {
      get when() {
        return e().options.toolbar.link;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Link),
          get children() {
            return m(qn);
          }
        });
      }
    }), he, We), k(Q, c(v, {
      get when() {
        return e().options.toolbar.image;
      },
      get children() {
        return c($, {
          onclick: () => r(g.Image),
          get children() {
            return m(In);
          }
        });
      }
    }), ke, Ue), k(Q, c(v, {
      get when() {
        return e().options.toolbar.upload;
      },
      get children() {
        return c($, {
          onclick: l,
          get children() {
            return [m(Rn), (() => {
              const Y = m(Pn);
              return o(Y), Y.addEventListener("change", i), Y.style.setProperty("display", "none"), Y;
            })()];
          }
        });
      }
    }), Ke, Qe), a;
  })();
}, Un = `.ink{color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column);gap:1rem;padding:var(--ink-internal-editor-padding, 0)}.ink .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde .ink-mde-editor-container{display:flex;flex-direction:column;flex-grow:1;gap:2em}.ink-mde .ink-mde-attribution{display:flex;font-size:.75em;justify-content:flex-end;opacity:.5}.ink-mde .ink-mde-attribution-link{color:currentColor;font-weight:600;text-decoration:none}.ink-mde .ink-mde-task-toggle{cursor:pointer;height:1rem;line-height:2em;margin:0 .25rem 0 0;position:relative;top:-1px;vertical-align:middle;width:1rem}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);border-left:.25rem solid currentColor;padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, Xn = /* @__PURE__ */ h("<style> </style>", 2), Kn = () => {
  const [e] = W(), [t, n] = z(ne(e()));
  return tt(() => {
    n(ne(e()));
  }), ye(() => {
    const o = window.matchMedia("(prefers-color-scheme: dark)"), r = (i) => {
      const {
        editor: l,
        root: a
      } = e();
      a.isConnected ? ue(e()).then((s) => {
        l.dispatch({
          effects: s
        }), n(ne(e()));
      }) : o.removeEventListener("change", r);
    };
    o.addEventListener("change", r);
  }), (() => {
    const o = m(Xn), r = o.firstChild;
    return oe(() => r.data = `.ink {
  ${t().join(`
  `)}
}
${Un}`), o;
  })();
}, Qn = /* @__PURE__ */ h('<div class="ink-mde-attribution"><span>powered by <a class="ink-mde-attribution-link" href="https://github.com/voracious/ink-mde" rel="noopener noreferrer" target="_blank">ink-mde</a></span></div>', 6), Yn = /* @__PURE__ */ h('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><div class="ink-mde-editor-container"><!#><!/><!#><!/></div></div>', 14), Zn = () => {
  const [e, t] = W(), n = (o) => {
    t(P(e(), {
      root: o
    }));
  };
  return (() => {
    const o = m(Yn), r = o.firstChild, [i, l] = b(r.nextSibling), a = i.nextSibling, [s, u] = b(a.nextSibling), x = s.nextSibling, [y, C] = b(x.nextSibling), S = y.nextSibling, M = S.firstChild, [A, B] = b(M.nextSibling), E = A.nextSibling, [f, p] = b(E.nextSibling);
    return n(o), Ye(o, yt, !1, !0), k(o, c(Kn, {}), i, l), k(o, c(v, {
      get when() {
        return e().options.files.clipboard || e().options.files.dragAndDrop;
      },
      get children() {
        return c(Ln, {});
      }
    }), s, u), k(o, c(v, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return c(Fn, {});
      }
    }), y, C), k(S, c(Mn, {}), A, B), k(S, c(v, {
      get when() {
        return e().options.interface.attribution;
      },
      get children() {
        return m(Qn);
      }
    }), f, p), ce(), o;
  })();
}, je = nt([() => ae(), (e) => typeof e == "function" ? e(ae()) : e]), Gn = (e) => c(je.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), W = () => ot(je), Ve = (e) => c(Gn, {
  get store() {
    return e.store;
  },
  get children() {
    return c(Zn, {
      get store() {
        return e.store;
      }
    });
  }
}), fo = (e) => e, Jn = (e, t = {}) => {
  const n = fe(t);
  return to(), Ze(() => c(Ve, {
    store: n
  }), e), Ee(n);
}, go = (e, t = {}) => e.querySelector(vt) ? Jn(e, t) : eo(e, t), eo = (e, t = {}) => {
  const n = fe(t);
  return Ge(() => c(Ve, {
    store: n
  }), e), Ee(n);
}, po = (e = {}) => (fe(e), ""), to = () => {
  let e, t;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), t = (n) => n && n.hasAttribute && (n.hasAttribute("data-hk") ? n : t(n.host && n.host instanceof Node ? n.host : n.parentNode)), ["click", "input"].forEach((n) => document.addEventListener(n, (o) => {
    let r = o.composedPath && o.composedPath()[0] || o.target, i = t(r);
    i && !e.completed.has(i) && e.events.push([i, o]);
  })), e.init = (n, o) => {
    e.r[n] = [new Promise((r, i) => o = r), o];
  }, e.set = (n, o, r) => {
    (r = e.r[n]) && r[1](o), e.r[n] = [o];
  }, e.unset = (n) => {
    delete e.r[n];
  }, e.load = (n, o) => {
    if (o = e.r[n])
      return o[0];
  };
};
export {
  V as Appearance,
  _t as Extensions,
  g as Markup,
  re as PluginType,
  ie as Selection,
  go as default,
  fo as defineOptions,
  Jn as hydrate,
  go as ink,
  eo as render,
  po as renderToString,
  to as solidPrepareForHydration
};
//# sourceMappingURL=client.js.map
